﻿using C1.Win.C1Chart;
using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;

namespace C1Chart_HightLightSymbol
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }


        float[] xp = new float[500];
        float[] yp = new float[500];
        int i;
        private void Form1_Load(object sender, EventArgs e)
        {

            Random rndValue = new Random();

            for (i = 0; i < 500; i++)
            {
                xp[i] = i;
                yp[i] = rndValue.Next(100);
            }

            c1Chart1.ChartGroups.ChartGroupsCollection[0].ChartData.SeriesList.Clear();

            ChartDataSeries cdseries =
               c1Chart1.ChartGroups.ChartGroupsCollection[0].ChartData.SeriesList.AddNewSeries();

            cdseries.X.CopyDataIn(xp);
            cdseries.Y.CopyDataIn(yp);

            c1Chart1.ChartGroups.ChartGroupsCollection[0].ChartData.SeriesList[0].LineStyle.Color = Color.CornflowerBlue ;

          
            ChartData cd = c1Chart1.ChartGroups.Group0.ChartData;

            // Adjust all the series symbols.  Want shape, but zero size
            // If the shape is none, then it will not highlight
            ChartDataSeriesCollection cdsc = cd.SeriesList;
            foreach (ChartDataSeries cds in cdsc)
            {
                cds.SymbolStyle.Shape = SymbolShapeEnum.Dot;
                cds.SymbolStyle.Size = 0;
            }

            // preset the highlight object parameters for the group.
            DataHighlight dhl = cd.HighLight;
            dhl.SymbolStyle.Color = Color.Blue ;
            dhl.SymbolStyle.Shape = SymbolShapeEnum.Dot;
            dhl.SymbolStyle.Size = 6;

            // Custom indicates user code will handle setting the series and point index.
            dhl.Activation = HighlightActivationEnum.Custom;

            // Set up the mouse move handler.
            c1Chart1.MouseMove += new MouseEventHandler(c1Chart1_MouseMove);
        }

        void c1Chart1_MouseMove(object sender, MouseEventArgs e)
        {
            // always get the Highlight object.  It will be set or cleared
            DataHighlight dhl = c1Chart1.ChartGroups.Group0.ChartData.HighLight;

            // if both are changed to valid values, then something needs to be highlighted
            int seriesIndex = -1, pointIndex = -1;

            // only check if the mouse is in the PlotArea.
            if (c1Chart1.ChartRegionFromCoord(e.X, e.Y) == ChartRegionEnum.PlotArea)
            {
                ChartGroup grp = c1Chart1.ChartGroups.Group0;
                int dist = 0;

                // if there is a single series in the chart like the google chart sample, then series index is always 0
                // and finding the closest series is not required.
                //
                // find the closest XCoord.
                if (grp.CoordToDataIndex(e.X, e.Y, CoordinateFocusEnum.XCoord, ref seriesIndex, ref pointIndex, ref dist))
                {
                    // if there are multiple series in the chart, then find the closest series.  this assumes that
                    // each series has the same X values.  if there is only 1 series, seriesIndex is already correct
                    if (grp.CoordToSeriesIndex(e.X, e.Y, PlotElementEnum.Series, ref seriesIndex, ref dist))
                    {
                        dhl.SeriesIndex = seriesIndex;
                        dhl.PointIndex = pointIndex;

                        label1.Text = "Data CoordinateX : " + c1Chart1.ChartGroups[0].ChartData.SeriesList[seriesIndex].X[pointIndex].ToString();
                        label2.Text = "Data CoordinateY: " + c1Chart1.ChartGroups[0].ChartData.SeriesList[seriesIndex].Y[pointIndex].ToString();
                    }
                }
            }

            // if either of these indices is has not been set, then the mouse must
            // not be in an appropriate location to highlight the data, so clear the highlight object.
            if (seriesIndex == -1 || pointIndex == -1)
            {
                dhl.SeriesIndex = -1;
                dhl.PointIndex = -1;
            }
        }
    }
}
